%bcond_without mead

%if %without mead
%if "%{?rhel}" == "6"
%bcond_without repolib
%endif
%global srcdir maven2-brew/com/github/relaxng/relaxngDatatype/%{namedversion}
%else
%bcond_with repolib
%global srcdir %{_sourcedir}
%endif

%define reltag .redhat_6
%define namedreltag -redhat-6
%global namedversion %{version}%{?namedreltag}

%define maven_version 2011.1-redhat-6

Name:           relaxngDatatype
Version:        2011.1
Release:        4%{?reltag}%{?dist}
Epoch:          0
Summary:        RELAX NG Datatype API
License:        BSD
Group:          Development/Java

%if %with mead
Source100: com.github.relaxng-relaxngDatatype-2011.1-redhat-6-sources.zip
Source101: com.github.relaxng-relaxngDatatype-2011.1-redhat-6-patches.zip
Source102: relaxngDatatype-2011.1-redhat-6-javadoc.jar
Source103: relaxngDatatype-2011.1-redhat-6-sources.jar
Source104: relaxngDatatype-2011.1-redhat-6.jar
Source105: relaxngDatatype-2011.1-redhat-6.pom
%endif

URL:            https://sourceforge.net/projects/relaxng
%if %without mead
%if 0
rm -rf relaxng-datatype-java relaxngDatatype-2011.1/ relaxngDatatype-2011.1.tar.bz2 .gitignore
git clone -q -n https://github.com/java-schema-utilities/relaxng-datatype-java.git
cd relaxng-datatype-java
git archive --prefix=relaxngDatatype-2011.1/ relaxngDatatype-2011.1 | bzip2 -9 > ../relaxngDatatype-2011.1.tar.bz2
cd ..
/usr/bin/rhpkg new-sources relaxngDatatype-2011.1.tar.bz2
/usr/bin/rhpkg prep
%endif
Source0:        relaxngDatatype-2011.1.tar.bz2
Patch0:         relaxngDatatype-pom.patch
%endif
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
%if %without mead
BuildRequires:  oss-parent >= 0:5
BuildRequires:  maven-scm-provider-gitexe >= 0:1.3
BuildRequires:  maven-scm-manager-plexus >= 0:1.3
#
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-default-skin
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-install-plugin
BuildRequires:  maven-jar-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-project-info-reports-plugin
BuildRequires:  maven-release-plugin
BuildRequires:  maven-resources-plugin
BuildRequires:  maven-site-plugin
BuildRequires:  maven-source-plugin
BuildRequires:  maven-surefire-plugin
BuildRequires:  surefire-junit4
%if %with repolib
BuildRequires:  zip
%endif
%else
BuildRequires:  unzip
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/relaxngDatatype-%{namedversion}-%{release}-root

%description
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package javadoc
Summary:        Javadoc for relaxngDatatype
Group:          Development/Documentation

BuildRequires:  jpackage-utils
Requires:       jpackage-utils

%description javadoc
%{summary}.

%prep
%if %without mead
%setup -q
%patch0 -p1 -b .sav0
%else
%setup -q -n relaxng-datatype-java -T -b 100
%endif

%if %with repolib
dir=`pwd`
pushd %{_sourcedir}
%{_bindir}/zip -9 -q ${dir}/com.github.relaxng-relaxngDatatype-%{namedversion}-patches.zip *.patch
%{_bindir}/zip -9 -q ${dir}/com.github.relaxng-relaxngDatatype-%{namedversion}-sources.zip * -x \*.patch
popd
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=remote-repository::default::file://`pwd`/maven2-brew
export MAVEN_OPTS=
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -DperformRelease -Denforcer.skip deploy javadoc:aggregate site
%endif

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p %{srcdir}/relaxngDatatype-%{namedversion}.jar %{buildroot}%{_javadir}/relaxngDatatype-%{namedversion}.jar
%{__cp} -p %{srcdir}/relaxngDatatype-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/relaxngDatatype-%{namedversion}-javadoc.jar
%{__cp} -p %{srcdir}/relaxngDatatype-%{namedversion}-sources.jar %{buildroot}%{_javadir}/relaxngDatatype-%{namedversion}-sources.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__cp} -p %{srcdir}/relaxngDatatype-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-relaxngDatatype.pom

# depmaps
%add_to_maven_depmap com.github.relaxng relaxngDatatype %{namedversion} JPP relaxngDatatype
[ %{name} = relaxngDatatype ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/relaxngDatatype

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/relaxngDatatype-%{namedversion}
%if %without mead
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/relaxngDatatype-%{namedversion}
%else
%{_bindir}/unzip -qq %{srcdir}/relaxngDatatype-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/relaxngDatatype-%{namedversion} -x META-INF/\*
%endif
%{__ln_s} relaxngDatatype-%{namedversion} %{buildroot}%{_javadocdir}/relaxngDatatype

# repolib
%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
export URL=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DgeneratePom=false -DgroupId=com.github.relaxng -DartifactId=relaxngDatatype -Dversion=%{namedversion} -Dclassifier=patches -Dpackaging=zip -Dfile=com.github.relaxng-relaxngDatatype-%{namedversion}-patches.zip -Durl=${URL}
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DgeneratePom=false -DgroupId=com.github.relaxng -DartifactId=relaxngDatatype -Dversion=%{namedversion} -Dclassifier=sources -Dpackaging=zip -Dfile=com.github.relaxng-relaxngDatatype-%{namedversion}-sources.zip -Durl=${URL}
pushd %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
baddirs=`%{_bindir}/find -type d \( -name "[0-9]*" -and -not -name %{namedversion} \)`
for baddir in ${baddirs}; do
    badver=`/bin/basename ${baddir} | %{__sed} "s/\./\\\./g;"`
    %{__mv} ${baddir}/* `/bin/echo ${baddir} | %{__sed} "s/${badver}/%{namedversion}/g;"`/ && %{__rm} -r ${baddir}/
done
popd
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap 

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/relaxngDatatype-%{namedversion}.jar
%{_javadir}/relaxngDatatype.jar
%{_javadir}/relaxngDatatype-%{namedversion}-sources.jar
%{_javadir}/relaxngDatatype-sources.jar
%{_mavenpomdir}/JPP-relaxngDatatype.pom
%{_mavendepmapfragdir}/relaxngDatatype

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/relaxngDatatype-%{namedversion}
%{_javadocdir}/relaxngDatatype
%{_javadir}/relaxngDatatype-%{namedversion}-javadoc.jar
%{_javadir}/relaxngDatatype-javadoc.jar

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Tue Apr 23 2013 Vladimir Dosoudil <dosoudil@redhat.com> - 0:2011.1-4.redhat_6
- BZ-901103

* Wed Apr 10 2013 David Walluck <dwalluck@redhat.com> 0:2011.1-3
- build with maven
- add javadoc and sources jars
- fix jar removal
- fix deploy
- create zips in prep
- do not generate pom for zips
- quiet setup
- BuildRequires: zip for src zips in repolib
- fix BuildRequires with repolib
- fix file list
- fix file perms
- remove ThaiOpenSourceCenter-copying.txt from %%doc
- fix repolib dir ownership
- use %%{_mavenpomdir} macro
- use %%{buildroot} macro
- fix pom URL
- remove obsolete repolib code
- remove obsolete pom

* Thu Feb 14 2013 Fernando Nasser <fnasser@redhat.com> 0:2011.1-2.redhat_4
- Include sources in repolib
- Fix release tag

* Tue Jan 29 2013 David Walluck <dwalluck@redhat.com> 0:2011.1-1
- fix broken maven support
- fix javadoc

* Mon Jan 21 2013 Fernando Nasser <fnasser@redhat.com> - 0:2011.1-0.2.redhat_2
- Fix repolib test

* Sat Sep 08 2012 Paul Gier <pgier@redhat.com> - 0:2011.1-0.1_redhat_3.4
- Update pom patch for latest bom

* Tue Aug 14 2012 Fernando Nasser <fnasser@redhat.com> - 0:2011.1-0.1_redhat_2.3
- Rebuild unsigned

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:2011.1-0.1_redhat_1.2
- Rebuild using cache signing

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:2011.1-0.1_redhat_1.1
- Rebuild using cache signing

* Wed Jan 18 2012 Lin Gao <lgao@redhat.com> - 0:2011.1-0.1_redhat_1
- upgrade to 2011.1
- werewolf phrase build

* Wed Feb 9 2011 Yiqiao Wang <yiwang@redhat.com> - 0:1.0-2.4.4
- Add %%update_maven_depmap in %%post and %%postun

* Tue Jan 25 2011 Yiqiao Wang <yiwang@redhat.com> - 0:1.0-2.4.3
- Add repolib 

* Mon Nov 20 2010 Yiqiao Wang <yiwang@redhat.com> - 0:1.0-2.4.2
- Rebuild for RHEL6
- fix %%{files} for signed jars

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0-2.4.1
- rebuilt

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.0-2.4
- Rebuild

* Thu Mar 04 2010 Yiqiao Wang <yiwang@redhat.com>- 0:1.0-2.3
- Rebuild on RHEL-4-EP-5, adjust release tag. 

* Thu Jun 07 2007 Fernando Nasser <fnasser@redhat.com>- 0:1.0-2jpp.ep1.2
- Remove unversioned Obsoletes for msv

* Mon Mar 12 2007 Fernando Nasser <fnasser@redhat.com>- 0:1.0-2jpp.ep1.1
- Rebuild

* Tue Apr 26 2005 Fernando Nasser <fnasser@redhat.com>- 0:1.0-2jpp_1rh
- First Red Hat build

* Wed Aug 25 2004 Fernando Nasser <fnasser@redhat.com>- 0:1.0-2jpp
- Require Ant > 1.6
- Rebuild with Ant 1.6.2

* Tue Jul 06 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0-1jpp
- First JPackage build from sources

